<app-loading *ngIf="loading"></app-loading>
<div class="content-header">
  <div>
    <mb-button *ngIf='objFunction?.create' mbButtonSize="MEDIUM" [mbIsDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value' mbButtonText="{{'polManagement.button.approveTranfer' | translate}}" (click)="waitingAproved()"
               mbButtonType="NO_BORDER"  mbButtonAvailableStyle="BtnCancelHasBorder">
    </mb-button>
    <mb-button *ngIf='objFunction?.import' mbButtonSize="MEDIUM" mbButtonText="{{'Import' | translate}}"
               mbButtonType="NO_BORDER"  mbButtonAvailableStyle="BtnCancelHasBorder" nzTrigger ='click' nz-dropdown [nzDropdownMenu]="menu">
    </mb-button>
    <mb-button *ngIf='objFunction?.generate' mbButtonSize="MEDIUM" mbButtonText="{{'polManagement.button.general' | translate}}"
               mbButtonType="NO_BORDER"  mbButtonAvailableStyle="BtnCancelHasBorder" nzTrigger ='click' nz-dropdown [nzDropdownMenu]="sumary">
    </mb-button>
    <mb-button *ngIf='objFunction?.generate' mbButtonSize="MEDIUM" mbButtonText="{{'polManagement.button.generalAll' | translate}}"
               mbButtonType="NO_BORDER" mbButtonAvailableStyle="PRIMARY" nzTrigger ='click' nz-dropdown [nzDropdownMenu]="sumaryAll">
    </mb-button>
  </div>
</div>

<div class="org-content-main">
  <div nz-row [nzGutter]="24">
    <div nz-col [nzSpan]="6">
      <hcm-mfe-employee-data-search-policy [mbCanText]="true" [ngModel]="" [ngModelOptions]="{standalone: true}"
                            [multiple]="false" (selectedChange)="onChange($event)" [mbDisable]="false" [functionCode]="functionCode"
                            mbLabelText="{{'polManagement.label.employeeCode' | translate}}">
      </hcm-mfe-employee-data-search-policy>
    </div>
    <div nz-col [nzSpan]="6">
      <mb-input-text [(ngModel)]="orgName" mbType="default" [mbMaxLength]="150" [defaultInput]="true" [mbReadOnly]="true"
                     mbLabelText="{{ 'polManagement.label.org' | translate }}" (click)="showPopup()"
                     mbPlaceholderText="{{ 'polManagement.placeHoder.chooseUnit' | translate }}"></mb-input-text>
      <em
        *ngIf="orgName"
        nz-icon
        class="icon-close"
        (click)="clearOrgInput()"
        nzType="close-circle"
        nzTheme="outline"
      ></em>
    </div>
    <div nz-col nzSpan="6" class="main-job-card__center">
      <mb-select-check-able [mbDataSelects]="empStatus" mbKeyLabel="value" mbKeyValue="key"
                            mbLabelText="{{'polManagement.label.status' | translate}}" mbPlaceholder="{{'polManagement.placeHoder.chooseStatus' | translate}}" mbType="default"
                            [mbShowAction]="false" (mbEventEmit)='onSelectStatus($event)' [(ngModel)]="listEmpStatus"></mb-select-check-able>
    </div>

    <div nz-col nzSpan="6" class="main-job-card__left">
      <mb-select [mbDataSelects]="listStatus" mbKeyLabel="value" mbKeyValue="key"
                 [(ngModel)]="objectSearch.flagStatus" [mbType]="'default'"
                 mbPlaceholder="{{ 'polManagement.placeHoder.chooseStatus' | translate }}"
                 mbLabelText="{{'polManagement.label.recordStatus' | translate}}"></mb-select>
    </div>

    <div nz-col [nzSpan]="6" class="main-job-card__left mg-input">
      <mb-select [mbDataSelects]="listPeriod" mbKeyLabel="value" mbKeyValue="value"
                 [(ngModel)]="objectSearch.periodDate" mbPlaceholder="mm/yyyy" [mbShowClear]='false'
                 mbLabelText="{{'polManagement.label.periodDate' | translate}}"></mb-select>
    </div>
    <div nz-col nzSpan="6" class="main-job-card__center salary-table" >
      <mb-select [mbDataSelects]="listTypeBonus" mbKeyLabel="value" mbKeyValue="key"
                 [(ngModel)]="objectSearch.isSpecial" [mbType]="'default'"
                 mbPlaceholder="{{ 'polManagement.placeHoder.chooseType' | translate }}"
                 mbLabelText="{{'polManagement.label.typeBonus' | translate}}"></mb-select>
    </div>
  </div>

  <div nz-row>
    <div class="org-content-main__search" nz-col [nzSpan]="24">
      <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='CUSTOM' (click)="onSearch()"
                 mbButtonText="{{'common.button.search' | translate}}">
      </mb-button>
      <mb-button *ngIf='objFunction?.export' mbButtonType="BORDER" mbButtonSize="VERY_LARGE" (click)="exportExcel()">
        <img src="../../../../../assets/images/icon/excel.svg" alt="" />
      </mb-button>
    </div>
  </div>
</div>
<div class="mb-tab">
  <nz-tabset nzType="editable-card" nzHideAdd (nzSelectedIndexChange)="changeTab($event)" [nzTabBarGutter]="0" [nzSelectedIndex]="selectTab">
    <nz-tab nzTitle="{{'polManagement.label.coefficientTH' | translate}}">
      <div>
        <mb-table-wrap [mbTitle]="''" [nonBg]="true" [extra]='false'>
          <mb-table [keyCheck]="'objectId'" [heightTable]="heightTable" [isUseTitle]='true' [isShowSeletedRow]='true'
                    (changePageNum)='changePage($event)'
                    [tableConfig]='tableConfig' [tableData]='dataTable' [checkedCashArrayFromComment]="checked"></mb-table>
        </mb-table-wrap>
      </div>
    </nz-tab>
    <nz-tab nzTitle="{{'polManagement.label.coefficientCB' | translate}}">
      <div>
        <mb-table-wrap [mbTitle]="''" [nonBg]="true" [extra]='false'>
          <mb-table [keyCheck]="'objectId'" [heightTable]="heightTable" [isShowSeletedRow]='true'
                    [isUseTitle]='true' (changePageNum)='changePage($event)'
                    [tableConfig]='tableConfig' [tableData]='dataTable' [checkedCashArrayFromComment]="checked"></mb-table>
        </mb-table-wrap>
      </div>
    </nz-tab>
    <nz-tab nzTitle="{{'polManagement.label.coefficientXL' | translate}}">
      <div>
        <mb-table-wrap [mbTitle]="''" [nonBg]="true" [extra]='false'>
          <mb-table [keyCheck]="'objectId'" [heightTable]="heightTable" (changePageNum)='changePage($event)' [isShowSeletedRow]='true'
                    [isUseTitle]='true'
                    [tableConfig]='tableConfig' [tableData]='dataTable' [checkedCashArrayFromComment]="checked"></mb-table>
        </mb-table-wrap>
      </div>
    </nz-tab>
    <nz-tab nzTitle="{{'polManagement.label.coefficientTCCV' | translate}}">
      <div>
        <mb-table-wrap [mbTitle]="''" [nonBg]="true" [extra]='false'>
          <mb-table [keyCheck]="'objectId'" [heightTable]="heightTable" (changePageNum)='changePage($event)' [isShowSeletedRow]='true'
                    [isUseTitle]='true'
                    [tableConfig]='tableConfig' [tableData]='dataTable' [checkedCashArrayFromComment]="checked"></mb-table>
        </mb-table-wrap>
      </div>
    </nz-tab>
    <nz-tab nzTitle="{{'polManagement.label.coefficientCN' | translate}}">
      <div>
        <mb-table-wrap [mbTitle]="''" [nonBg]="true" [extra]='false'>
          <mb-table [keyCheck]="'objectId'" [heightTable]="heightTable" (changePageNum)='changePage($event)' [isShowSeletedRow]='true'
                    [isUseTitle]='true'
                    [tableConfig]='tableConfig' [tableData]='dataTable' [checkedCashArrayFromComment]="checked"></mb-table>
        </mb-table-wrap>
      </div>
    </nz-tab>

  </nz-tabset>
</div>
<ng-template #flagStatusTmpl let-flagStatus='flagStatus'>
  <div class="display-center" *ngIf='flagStatus'>
    <nz-tag [nzColor]="renderFlagStatus(flagStatus).class">
      {{renderFlagStatus(flagStatus).text}}
    </nz-tag>
  </div>
</ng-template>

<ng-template #coefficientTmpl let-dataObj='dataObj'>
  <div class="display-center">
    <mb-input-text [(ngModel)]="dataObj.realCoefficient" (keypress)='onKeyPress($event)' (paste)="onPaste($event)"
                   [mbDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value'
                   [mbType]="submit && dataObj._checked && (!dataObj.isValidNumber || !dataObj.realCoefficient)? 'error' : 'default'"></mb-input-text>
  </div>
</ng-template>
<ng-template #fromDateTmpl let-dataObj='dataObj'>
    <div>
      <mb-date-picker mbFormat="dd/MM/yyyy" [mbDisabled]='this.objectSearch.periodDate !== this.listPeriod[0]?.value'
                       [(ngModel)]="dataObj.fromDate" [mbDisabledDate]="disabledEndtDate"
                      [mbType]="submit && dataObj._checked && (!dataObj.isValid || !dataObj.fromDate) ? 'error' : 'default'">
      </mb-date-picker>
    </div>
</ng-template>
<ng-template #toDateTmpl let-dataObj='dataObj'>
  <div>
    <mb-date-picker mbFormat="dd/MM/yyyy" [mbDisabled]='this.objectSearch.periodDate !== this.listPeriod[0]?.value'
                    [(ngModel)]="dataObj.toDate" [mbDisabledDate]="disabledEndtDate"
                    [mbType]="submit && dataObj._checked && (!dataObj.isValid || !dataObj.toDate)? 'error' : 'default'">
    </mb-date-picker>
  </div>
</ng-template>
<ng-template #footerTmplUploadFile>
  <section class="flex-footer__uploadfile">
    <mb-button (click)="modalRef.getContentComponent().save()" mbButtonAvailableStyle="PRIMARY" mbButtonSize="VERY_LARGE"
               mbButtonText="{{'common.button.uploadFile' | translate}}"
               mbButtonType="NO_BORDER"></mb-button>
    <mb-button (click)="modalRef.destroy()"
               *ngIf="objFunction?.view" class="flex-footer__uploadfile--button-left"
               mbButtonAvailableStyle="BtnCancelHasBorder" mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
  </section>
</ng-template>
<ng-template #ratingTmpl let-dataObj='dataObj'>
  <div>
    <mb-select [mbDataSelects]="listRating" mbKeyLabel="cldName" mbKeyValue="claCode" [(ngModel)]="dataObj.claCode"
               [mbShowClear]='false'  [mbDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value' (mbSelect)='changeSelect($event,dataObj)'
               [mbType]="'default'"  mbPlaceholder="{{ 'polManagement.placeHoder.chooseStatus' | translate }}">
    </mb-select>
  </div>
</ng-template>
<ng-template #tccvTmpl let-dataObj='dataObj'>
  <div>
    <mb-select [mbDataSelects]="listTCCV" mbKeyLabel="lvaMean" mbKeyValue="lvaValue" [(ngModel)]="dataObj.complexValue"
               [mbShowClear]='false'  [mbDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value' (mbSelect)='changeSelect($event,dataObj)'
               [mbType]="'default'"  mbPlaceholder="{{ 'polManagement.placeHoder.chooseStatus' | translate }}">
    </mb-select>
  </div>
</ng-template>
<ng-template #rankGroupTmpl let-dataObj='dataObj'>
  <div>
    <mb-select [mbDataSelects]="listRankGroup" mbKeyLabel="name" mbKeyValue="id" [(ngModel)]="dataObj.positionGroupId"
               [mbShowClear]='false' [mbDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value' (mbSelect)='changeSelect($event,dataObj)'
               [mbType]="'default'"  mbPlaceholder="{{ 'polManagement.placeHoder.chooseStatus' | translate }}">
    </mb-select>
  </div>
</ng-template>
<ng-template #actionTmpl let-dataObj='dataObj'>
  <div class="btn-add">
      <mb-button *ngIf='objFunction?.create' mbButtonType="NO_BORDER" mbButtonSize="MEDIUM" mbButtonAvailableStyle='CONTENT'
                 [mbIsDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value' (click)='addNew(dataObj.index)'>
        <img src="assets/images/icon/add_circle_outline.svg" alt=""
             nz-tooltip nzTooltipTitle="{{'polManagement.label.create' | translate}}" nzTooltipPlacement="bottom"/>
      </mb-button>
      <mb-button *ngIf='objFunction?.delete' mbButtonType="NO_BORDER" mbButtonSize="MEDIUM" mbButtonAvailableStyle='CONTENT'
                 [mbIsDisable]='this.objectSearch.periodDate !== this.listPeriod[0]?.value' (click)='deleteRecord(dataObj.index,dataObj)'>
        <img src="assets/images/icon/delete_outline.svg" alt=""
             nz-tooltip nzTooltipTitle="{{'polManagement.label.delete' | translate}}" nzTooltipPlacement="bottom"/>
      </mb-button>
  </div>
</ng-template>
<nz-dropdown-menu #menu="nzDropdownMenu">
  <ul nz-menu>
    <li nz-menu-item (click)="onClickTypeImport('',footerTmplUploadFile)"><span nz-icon nzType="upload" nzTheme="outline" class='pr-15'></span>
      {{'polManagement.label.importBonus' | translate}}
    </li>
    <li nz-menu-item (click)="onClickTypeImport('ĐB',footerTmplUploadFile)"><span nz-icon nzType="upload" nzTheme="outline" class='pr-15'></span>
      {{'polManagement.label.importBonusSpecial' | translate}}
    </li>
  </ul>
</nz-dropdown-menu>

<nz-dropdown-menu #sumary="nzDropdownMenu">
  <ul nz-menu>
    <li nz-menu-item>
      {{'polManagement.label.sumarybyList' | translate}}
    </li>
    <li nz-menu-item (click)="onClickSumary()">
      {{'polManagement.label.sumary' | translate}}
    </li>
  </ul>
</nz-dropdown-menu>
<nz-dropdown-menu #sumaryAll="nzDropdownMenu">
  <ul nz-menu>
    <li nz-menu-item>
      {{'polManagement.label.sumarybyList' | translate}}
    </li>
    <li nz-menu-item (click)="onClickSumary('ALL')">
      {{'polManagement.label.sumary' | translate}}
    </li>
  </ul>
</nz-dropdown-menu>
